main(){
	maps\mp\_load::main();
	AmbientPlay("amb_state1");
	setCullFog(500,1500,0,0,0,0);
	setcvar("cg_drawgun","0");

	level.infopic["cure_bliSwitch"]="textures/nm_cure/cure_bliSwitch.dds";
	level.infopic["cure_canSwitch"]="textures/nm_cure/cure_canSwitch.dds";
	level.infopic["cure_noSwitch"]="textures/nm_cure/cure_noSwitch.dds";
	precacheShader(level.infopic["cure_bliSwitch"]);
	precacheShader(level.infopic["cure_canSwitch"]);
	precacheShader(level.infopic["cure_noSwitch"]);
	precacheShader("black");

	level.cure_hud = newHudElem(); 
	level.cure_hud.x = 100; 
	level.cure_hud.y = 435;

	level.canSwitchState = true;
	level.hudEffect = false;
	level.code = [];
	level.codeCount = 0;

	getent("nm_cure_start","targetname") thread nm_cure_start();
	getent("nm_cure_2_1","targetname") thread nm_cure_2_1();
	getent("nm_cure_2_2","targetname") thread nm_cure_2_2();
	getent("nm_cure_3_t","targetname") thread nm_cure_3();
	thread nm_cure_4();
	thread nm_cure_5();
	thread nm_cure_6();
	thread nm_cure_7();
	thread nm_cure_8();
	thread nm_cure_9();
	thread nm_cure_10();
	thread nm_cure_11();
	thread nm_cure_13_2();
}

nm_cure_start(){
	self waittill("trigger",user);
	user.newSave = undefined;
	user thread stateChanger();
	user thread randomSounds();
	getent("nm_cure_noSwitch","targetname") thread stateChecker(user);
	for(i=1;i<7;i++)
		getent("nm_cure_s_"+i,"targetname") thread savePos(i);
	actualPlayer=user;
	while(1){
		self waittill("trigger",user);
		user takeAllWeapons();
		user giveWeapon("luger_mp");
		user switchtoweapon("luger_mp");
		if(user!=actualPlayer)
			user thread maps\mp\gametypes\dm::spawnSpectator();
		else if(isDefined(user.newSave)){
			setcvar("timescale",1);
			user.state=true;
			user thread doEffect(1);
			user setOrigin(user.newSave);
		}
	}	
}

savePos(i){
	loc[1]=(0,448,0);
	loc[2]=(0,1056,264);
	loc[3]=(160,2720,48);
	loc[4]=(560,3328,0);
	loc[5]=(2616,1600,0);
	loc[6]=(2144,2720,520);
	self waittill("trigger",user);
	user.newSave=loc[i];
}

stateChecker(user){
	level.canSwitchState=!(user isTouching(self));
	thread updateHUD(1);
	wait 0.1;
	self thread stateChecker(user);		
}

useChecker(){
	if(self meleeButtonPressed())
		level notify("buttonPressed");
	else
		level notify("buttonReleased");
	wait 0.05;
	self thread useChecker();
}

doEffect(i){
	self playLocalSound("cure_switchState");
	AmbientStop(0.1);
	AmbientPlay("amb_state"+i,0.1);
	setCullFog(0,1,0,0,0,0);
	wait 0.1;
	if(self.state)
		setCullFog(500,1500,0,0,0,0); 
	else
		setCullFog(0,15000,0,0,0,0);
}

updateHUD(i){
	if(i==1&&!level.hudEffect)
		if(level.canSwitchState)
			level.cure_hud setShader(level.infopic["cure_canSwitch"],39,39);
		else
			level.cure_hud setShader(level.infopic["cure_noSwitch"],39,39);
	else if(i==2&&!level.hudEffect){
		level.hudEffect=true;
		for(i=0;i<4;i++){
			level.cure_hud setShader(level.infopic["cure_bliSwitch"],39,39);
			wait .2;
			if(level.canSwitchState)
				level.cure_hud setShader(level.infopic["cure_canSwitch"],39,39);
			else
				level.cure_hud setShader(level.infopic["cure_noSwitch"],39,39);
			wait .15;
		}
		level.hudEffect=false;
	}
}

stateChanger(){
	self thread useChecker();
	self.state=true;
	while(1){
		level waittill("buttonPressed");
		if(isAlive(self)&&level.canSwitchState)
			if(self.state){
				self.state=false;
				self thread doEffect(2);
				self setOrigin(self.origin+(640,0,0));
			}
			else{
				self.state=true;
				self thread doEffect(1);
				self setOrigin(self.origin-(640,0,0));
			}
		else if(isAlive(self))
			thread updateHUD(2);
		level waittill("buttonReleased");
	}
}

randomSounds(){
	wait(randomInt(30)+30);
	if(!self.state)
		self playLocalSound("cure_rand"+(randomInt(4)+1));
	self thread randomSounds();
}

nm_cure_2_1(){
	self moveZ(-88,1.5,.5,.5);
	self waittill("movedone");
	wait 1;
	self moveZ(88,1.5,.5,.5);
	self waittill("movedone");
	wait 1;
	self thread nm_cure_2_1();
}

nm_cure_2_2(){
	self moveY(328,3,.5,.5);
	self waittill("movedone");
	self moveY(-328,3,.5,.5);
	self waittill("movedone");
	self thread nm_cure_2_2();
}

nm_cure_3(){
	self waittill("trigger",user);
	user playLocalSound("cure_click");
	getent("nm_cure_3_s","targetname") playSound("cure_platform");
	getent("nm_cure_3_b","targetname") moveY(8,0.25);
	getent("nm_cure_3_1","targetname") moveY(48,2,1,1);
	getent("nm_cure_3_2","targetname") moveY(-48,2,1,1);
}

nm_cure_4(){
	getent("nm_cure_4_1","targetname") waittill("trigger",user);
	getent("nm_cure_4_2","targetname") waittill("trigger");
	user playLocalSound("cure_hit");
	AmbientStop();
	AmbientPlay("amb_scare1",3);
	wait 0.1;
	setCullFog(0,1,1,1,1,0);
	setcvar("cg_draw2d","0");
	user setOrigin((-704,1184,680));
	user.maxspeed=60;
	wait 0.1;
	setCullFog(0,750,0,0,0,0.5);
	getent("nm_cure_4_3","targetname") waittill("trigger");
	setCullFog(0,1,0,0,0,2);
	AmbientStop(1);
	AmbientPlay("amb_state1",1);
	wait 1;
	user setOrigin((160,2208,1600));
	user.newSave=(160,2208,1600);
	user.maxspeed=190;
	setCullFog(0,1,1,1,1,0);
	setcvar("cg_draw2d","1");
	wait 0.05;
	setCullFog(0,1500,0,0,0,2);
}

nm_cure_5(){
	getent("nm_cure_5_1","targetname") waittill("trigger",user);
	user playLocalSound("cure_click");
	getent("nm_cure_5_s","targetname") playSound("cure_platform2");
	getent("nm_cure_5_4_1","targetname") moveY(240,3.5,3.5,0);
	getent("nm_cure_5_4_2","targetname") moveY(-240,3.5,3.5,0);
	getent("nm_cure_5_2","targetname") waittill("trigger");
	user playLocalSound("cure_click");
	getent("nm_cure_5_s","targetname") playSound("cure_water");
	getent("nm_cure_5_3","targetname") moveZ(-152,5,5,0);
	wait 3.5;
	getent("nm_cure_5_5","targetname") thread maps\mp\_utility::triggerOff();
}

nm_cure_6(){
	getent("nm_cure_6_5","targetname") waittill("trigger",user);
	getent("nm_cure_6","targetname") waittill("trigger");
	user playLocalSound("cure_hit");
	AmbientStop();
	AmbientPlay("amb_scare2",3);
	setCullFog(0,1,1,1,1,0);
	setcvar("cg_draw2d","0");
	user setOrigin((-416,2144,320));
	user.maxspeed=60;
	user.state=true;
	wait 0.1;
	setCullFog(0,750,0,0,0,2.9);
	getent("nm_cure_6_6","targetname") waittill("trigger");
	getent("nm_cure_6_1","targetname") waittill("trigger");
	wait 0.5;
	user playLocalSound("cure_hit2");
	for(i=0;i<2;i++){
		getent("nm_cure_6_2","targetname") hide();
		wait 0.4;
		getent("nm_cure_6_2","targetname") show();
		wait 0.3;
	}
	getent("nm_cure_6_3","targetname") waittill("trigger");
	user playLocalSound("cure_hit");
	AmbientStop();
	AmbientPlay("amb_state1",0.25);
	getent("nm_cure_6_4","targetname") delete();
	wait 0.25;
	setCullFog(0,1,1,1,1,0);
	setcvar("cg_draw2d","1");
	user setOrigin((1712,-80,-152));
	user.newSave=(1712,-80,-152);
	user.maxspeed=190;
	wait 0.05;
	setCullFog(0,1500,0,0,0,2);
	for(i=1;i<5;i++)
		getent("nm_cure_7_3_"+i,"targetname") thread nm_cure_7_3_c(user);
}

nm_cure_7(){
	for(i=1;i<8;i++){
		getent("nm_cure_7_1_"+i,"targetname") thread nm_cure_7_1();
		wait 0.1;
	}
	for(i=1;i<5;i++){
		getent("nm_cure_7_2_"+i,"targetname") thread nm_cure_7_2(randomFloat(1)+0.25);
		wait 0.5;
	}
	for(i=1;i<5;i++){
		getent("nm_cure_7_3_"+i,"targetname") thread nm_cure_7_3(randomFloat(1)+0.5);
		wait 0.25;
	}
	getent("nm_cure_7_t","targetname") thread nm_cure_7_t();
	getent("nm_cure_7_s","targetname") playLoopSound("cure_spinner");
	while(1){
		getent("nm_cure_7_4_1","targetname") rotatepitch(3600,5);
		getent("nm_cure_7_4_2","targetname") rotatepitch(-3600,5);
		wait 5;
	}
}

nm_cure_7_1(){
	self moveX(64,1.5,.75,.75);
	self waittill("movedone");
	self moveX(-64,1.5,.75,.75);
	self waittill("movedone");
	self thread nm_cure_7_1();
}

nm_cure_7_2(i){
	self moveX(-112,i,i/2,i/2);
	self waittill("movedone");
	self moveX(112,i,i/2,i/2);
	self waittill("movedone");
	self thread nm_cure_7_2(i);
}

nm_cure_7_3(i){
	self moveZ(152,i,i/2,i/2);
	self waittill("movedone");
	self moveZ(-152,i,i/2,i/2);
	self waittill("movedone");
	self thread nm_cure_7_3(i);
}

nm_cure_7_3_c(user){
	if(user isTouching(self))
		user suicide();
	wait 0.1;
	self thread nm_cure_7_3_c(user);
}

nm_cure_7_t(){
	self waittill("trigger",user);
	while(user isTouching(self)){
		user setOrigin(user.origin+(0,6,0));
		wait 0.05;
	}
	self thread nm_cure_7_t();
}

nm_cure_8(){
	thread nm_cure_8_1();
	while(1){
		getent("nm_cure_8","targetname") waittill("trigger");
		thread updateHUD(2);
		for(i=1;i>.2;i-=0.05){
			setcvar("timescale",i);
			wait 0.05;
		}
		wait 5;
	}
}

nm_cure_8_1(){
	getent("nm_cure_8_1","targetname") waittill("trigger",user);
	user.newSave=(2912,864,-640);
	setcvar("timescale",1);
	getent("nm_cure_7_s","targetname") stopLoopSound("cure_spinner");
	user playLocalSound("cure_platform3");
	getent("nm_cure_8_2","targetname") moveZ(-1024,13,0,13);
	getent("nm_cure_8_3","targetname") moveZ(-1024,13,0,13);
	getent("nm_cure_8_2","targetname") waittill("movedone");
	getent("nm_cure_8_4","targetname") thread nm_cure_8_4();
}

nm_cure_8_4(){
	self waittill("trigger",user);
	if(user.state){
		user.state=false;
		AmbientStop();
		AmbientPlay("amb_state2");
		setCullFog(0,15000,0,0,0,0);
	}
	wait 10;
	self thread nm_cure_8_4();		
}

nm_cure_9(){
	m=spawn("script_model",(0,0,0));
	while(1){
		getent("nm_cure_9","targetname") waittill("trigger",user);
		m.origin = user.origin;
		user linkto(m);
		level waittill("buttonReleased");
		level waittill("buttonPressed");
		user unlink();
		wait 0.05;
	}
}

nm_cure_10(){
	for(i=0;i<9;i++)
		p[i]=false;
	for(i=0;i<8;i++){
		t=randomInt(8)+1;	
		if(p[t])
			i--;	
		else{
			level.code[i]=t;
			p[t]=true;
			getent("nm_cure_10_"+(i+1),"targetname") thread nm_cure_10_c(i+1);
		}
	}
}

nm_cure_10_c(i){
	self waittill("trigger",user);
	user playLocalSound("cure_doorsTel");
	user setOrigin((2976,4440,320));
	if(level.code[level.codeCount]==i){		
		getent("nm_cure_10_"+i+"_s","targetname") hide();
		level.codeCount++;
		if(level.codeCount==8)
			user setOrigin((1088,1784,264));		
	}
	else if(level.codeCount>0){
		for(j=1;j<9;j++)
			getent("nm_cure_10_"+j,"targetname") thread maps\mp\_utility::triggerOff();
		for(j=level.codeCount-1;j>=0;j--){
			wait 0.5;
			getent("nm_cure_10_"+level.code[j]+"_s","targetname") show();
			user playLocalSound("cure_doorsPop");
		}
		for(j=1;j<9;j++)
			getent("nm_cure_10_"+j,"targetname") thread maps\mp\_utility::triggerOn();
		level.codeCount=0;
	}
	wait 0.5;
	getent("nm_cure_10_"+i,"targetname") thread nm_cure_10_c(i);
}

nm_cure_11(){
	getent("nm_cure_11_1","targetname") hide();
	getent("nm_cure_13","targetname") hide();
	getent("nm_cure_11","targetname") waittill("trigger",user);
	user thread loopBreathing();
	user thread loopHeartbeat(1);
	setCullFog(0,500,0,0,0,0);
	setcvar("cg_draw2d",0);
	user disableWeapon();
	user thread lockAngles();
	user setOrigin((1088,1784,264));
	wait 5;
	user playLocalSound("cure_diaDosage");
	wait 3.5;
	user playLocalSound("cure_fxDosage");
	getent("nm_cure_11_1","targetname") show();
	for(i=.8;i>0.5;i-=.1){
		level notify("stopHeartbeat");
		user thread loopHeartbeat(i);
		wait .5;
	}
	AmbientStop(3);
	AmbientPlay("amb_state2",3);
	setCullFog(5,180,0,0,0,2);
	user thread zoomVisionOut();
	wait 4;
	setCullFog(0,1,1,1,1,0);
	user playLocalSound("cure_switchState");
	user setOrigin((1792,832,448));
	level notify("stopLimitingAngles");
	setcvar("cg_fov",80);
	wait 0.5;
	user thread loopVision();
	setCullFog(0,15000,0,0,0,1);
	thread nm_cure_12();
	getent("nm_cure_12_t_2","targetname") thread nm_cure_12_t();
	getent("nm_cure_12_t","targetname") waittill("trigger");
	setCullFog(0,1,1,1,1,0);
	user playLocalSound("cure_switchState");
	level notify("stopLoopvision");
	user setPlayerAngles((0,90,0));
	user setOrigin((1312,1648,-416));
	level notify("stopHeartbeat");
	user thread loopHeartbeat(.5);
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	getent("nm_cure_13_t_2","targetname") thread nm_cure_13_3();
	getent("nm_cure_13_t","targetname") waittill("trigger");
	setCullFog(0,1,1,1,1,0);
	user playLocalSound("cure_switchState");
	user setOrigin((-1008,648,-184));
	level notify("stopHeartbeat");
	user thread loopHeartbeat(.4);
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	getent("nm_cure_14","targetname") thread nm_cure_14();
	getent("nm_cure_14_t","targetname") thread nm_cure_14_t();
	getent("nm_cure_14_t_2","targetname") waittill("trigger");
	setCullFog(0,1,1,1,1,0);
	user playLocalSound("cure_switchState");
	user thread lockAngles();
	user setOrigin((1088,1784,264));
	level notify("stopHeartbeat");
	user thread loopHeartbeat(.3);
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	wait 3;
	level notify("stopHeartbeat");
	user thread loopHeartbeat(.2);
	wait 5;
	level notify("stopHeartbeat");
	user thread loopHeartbeat(.1);
	wait 5;
	if(getcvar("cg_drawfps")==1){
		setcvar("cg_drawfps","0");
		thereWasFPS = true;
	}
	setcvar("cg_draw2d",1);
	level.hudEffect=true;
	level.cure_hud.x=0;
	level.cure_hud.y=0;
	level.cure_hud setShader("black",640,480);
	level notify("stopHeartbeat");
	level notify("stopBreathe");
	AmbientStop();
	AmbientPlay("amb_null");
	wait 0.05;
	user playLocalSound("cure_fxFlatline");
	wait 5;
	iprintlnbold("Map Made By ^1Nightmare");
	wait 2;
	iprintlnbold("www.NightmareMaps.us.ms");
	wait 4;
	iprintlnbold(" ");
	iprintlnbold("Special Thanks To:");
	wait 2;
	iprintlnbold("Soviet");
	wait 6;
	iprintlnbold(" ");
	iprintlnbold("Sounds used from:");
	wait 0.5;
	iprintlnbold("Quake 3");
	wait 0.5;
	iprintlnbold("HL2 Mod: Korsakovia");
	wait 0.5;
	iprintlnbold("Half Life 1");
	wait 5;
	iprintlnbold(" ");
	iprintlnbold("Thanks for playing!");
	wait 5;
	thread fadeout(level.cure_hud);
	if(thereWasFPS)
		setcvar("cg_drawfps","1");
	setcvar("cg_drawgun",1);
	user setOrigin((1088,2080,256));
	user.newSave=(1088,2080,256);
	level notify("stopLimitingAngles");
	user enableWeapon();
}

nm_cure_12(){
	for(i=1;i<9;i++){
		getent("nm_cure_12_"+i,"targetname") moveY(-1168,7-(i*0.5));
		wait 2;
	}
	for(i=1;i<9;i++)
		getent("nm_cure_12_"+i,"targetname") moveY(1168,0.05);
	thread nm_cure_12();
}

nm_cure_12_t(){
	self waittill("trigger",user);
	user playLocalSound("cure_switchState");
	setCullFog(0,1,1,1,1,0);
	user setOrigin((1792,832,448));
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	self thread nm_cure_12_t();
}

nm_cure_13_2(){
	dist[1]=96;
	dist[2]=224;
	dist[3]=480;
	dist[4]=608;
	dist[5]=864;
	dist[6]=992;
	dist[7]=1184;
	dist[8]=1312;
	for(i=1;i<9;i++){
		getent("nm_cure_13_"+i,"targetname") thread nm_cure_13_2_m(dist[i]);
		wait 1.5;
	}
}

nm_cure_13_2_m(i){
	self moveY(0-i,12);
	self waittill("movedone");
	self hide();
	self moveY(1408,0.05);
	self waittill("movedone");
	self show();
	self thread nm_cure_13_2_m(1408);
}

nm_cure_13_3(){
	self waittill("trigger",user);
	user playLocalSound("cure_switchState");
	setCullFog(0,1,1,1,1,0);
	user setOrigin((1312,1648,-416));
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	self thread nm_cure_13_3();
}


nm_cure_14(){
	self rotateyaw(360,20);
	getent("nm_cure_14_1","targetname") rotateyaw(360,20);
	self waittill("rotatedone");
	self thread nm_cure_14();
}


nm_cure_14_t(){
	self waittill("trigger",user);
	user playLocalSound("cure_switchState");
	setCullFog(0,1,1,1,1,0);
	user setOrigin((-1008,648,-184));
	wait 0.05;
	setCullFog(0,15000,0,0,0,0.5);
	self thread nm_cure_14_t();
}

lockAngles(){
	level endon("stopLimitingAngles");
	self setPlayerAngles((0,90,0));
	wait 0.05;
	self thread lockAngles();
}

loopBreathing(){
	level endon("stopBreathe");
	self playLocalSound("cure_fxBreathe");
	wait 7.2;
	self thread loopBreathing();
}

loopHeartbeat(i){
	level endon("stopHeartbeat");
	self playLocalSound("cure_fxHeartbeat");
	wait i;
	self thread loopHeartbeat(i);
}

zoomVisionOut(){
	for(i=80;i<161;i++){
		setcvar("cg_fov",i);
		wait 0.05;
	}
}

loopVision(){
	level endon("stopLoopvision");
	for(i=0;i<360;i+=.5){
		self setPlayerAngles((0,90,i));
		wait 0.05;
	}
	self thread loopVision();
}

fadeout(elem){
	elem fadeOverTime(3);
	elem.alpha = 0;
}